/*This file includes the Mata funcitons used in different components of RLTDM*/
/*diff() calculates the difference between two rows of the matrix*/
/*shrcat() calculates the share of the sum of the row in the matrix*/
/*sumcat() calculates sum of the rows when the matrix is categorised into C categories */ 
/*for example categories could be regions*/
mata
function diff(real matrix M){
		O = J(rows(M)-1, cols(M),0)
		O = M[2..rows(M),.]:-M[1..(rows(M)-1),.] 

	return(O)
	}

	
	function shrcat(real matrix M, C){
		S = J(rows(M), cols(M)/C,0)
		O = J(rows(M), cols(M),0)
		for (j=1;j<=(cols(M)/C);j++) {
			S[.,j] = rowsum(M[.,(j-1)*C+1..j*(C)])
			O[.,(j-1)*C+1..j*(C)] = M[.,(j-1)*C+1..j*(C)]:/S[.,j]
		}
		return(O)
	}
	
	function sumcat(real matrix M, C){
		S = J(rows(M), cols(M)/C,0)
		for (j=1;j<=(cols(M)/C);j++) {
			S[.,j] = rowsum(M[.,(j-1)*C+1..j*(C)])
		}
		return(S)
	}
end